Hello, it has been a minute but I finally have a tutorial for you all: Sudoku Validator. I first saw this question on Pramp. I finally came up with a great solution that I feel is teachable enough. My friend got asked this question from Squarespace two years ago and I finally decided to tackle it.

I failed, but shout out to the internet for eventually giving me the answer. Hey everyone. Here is the video…. Hello everyone. I have another algorithm for you all today. I have two versions for you all, both in Python. This post makes a copy of the original matrix and adds the correct values to it, the second….

Hey everyone, glad to finally get this tutorial out to you all. I hope to simplify it for you all….

Just to leave my feedback. Disclaimer: I am in no way being paid for this review and I…. The question is 3. I discovered this implementation on-line and commented it for better understanding.

The video below is also an explanation of the process. The stack of plates question basically asks that,…. Hello, Everyone.

The first video below shows a visualization of what is expected. The second video is of me explaining the concept and implementing the code…. My 3rd question from Pramp. The Westfield Mall management is trying to figure out what the busiest moment at the mall was last year. Each data point is represented as an integer array whose size is 3. The values at indices 0, 1 and 2 are…. If you count the mock interviews it would be Here is the YouTube video for…. This was the question I received in my first ever Pramp interview.

I failed terribly at it, but now it seems so easy. Last time I posted about solving algorithms, currently I am at Given an array of integers where each element represents the max number of steps that can be made forward from that element. Write a function to return the minimum number of jumps to reach the end of the array starting from the first element. If an element is 0, then cannot move through that element. First element is 1, so can only go to 3. Second element is 3, so can make at most 3 steps eg to 5 or 8 or 9.

Method 1 Naive Recursive Approach A naive approach is to start from the first element and recursively call for all the elements reachable from first element. The minimum number of jumps to reach end from first can be calculated using minimum number of jumps needed to reach end from the elements reachable from first.

If we trace the execution of this method, we can see that there will be overlapping subproblems. For example, minJumps 3, 9 will be called two times as arr[3] is reachable from arr[1] and arr[2].

So this problem has both properties optimal substructure and overlapping subproblems of Dynamic Programming. Method 2 Dynamic Programming In this method, we build a jumps[] array from left to right such that jumps[i] indicates the minimum number of jumps needed to reach arr[i] from arr[0].

Finally, we return jumps[n-1]. Method 3 Dynamic Programming In this method, we build jumps[] array from right to left such that jumps[i] indicates the minimum number of jumps needed to reach arr[n-1] from arr[i]. Finally, we return arr[0]. Minimum number of jumps to reach end Set 2 O n solution. Please write comments if you find anything incorrect, or you want to share more information about the topic discussed above. Writing code in comment? Please use ide.

Minimum number of jumps to reach end Minimum number of jumps to reach end Set 2 O n solution Count of subsets with sum equal to X Split the given string into Primes : Digit DP Count of numbers in range which are divisible by M and have digit D at odd places Median of sliding window in an array Eggs dropping puzzle Set 2 Minimize total cost without repeating same task in two consecutive iterations Maximum sum path in a Matrix Minimum increment or decrement required to sort the array Top-down Approach Count number of ways to arrange first N numbers Minimum window size containing atleast P primes in every window of given range Find the numbers from 1 to N that contains exactly k non-zero digits Maximum size of square such that all submatrices of that size have sum less than K Count the numbers with N digits and whose suffix is divisible by K Count number of increasing sub-sequences : O NlogN Count maximum occurrence of subsequence in string such that indices in subsequence is in A.

Python3 program to find Minimum. Returns minimum number of jumps. Base case: when source and. Traverse through all the points. Driver program to test above function. This code is contributed by Soumen Ghosh.

Write "Minimum number of jumps to reach end is ". Find the minimum number of. Driver Program to test above function. Length.

Python3 progrma to find Minimum. Returns Minimum number of. Minimum number of jumps needed. Start from the second element. If arr[i] is 0 then arr[n-1]. If we can directly reach to. Otherwise, to find out the.

Handle overflow.This article is also available on my blog. I started leetcode as a daily routine early Nov while I was taking part time online master couse Machine Learning at Geogia Tech and having full time job. It was quite hard to find enough time to tackle a single question from scratch. So, my strategy was to read questions and most upvoted answers in the discussion to get the sense of questions tag by tag. I found that it is extremely helpful for me to read solutions before attempting to solve the problems all by myself.

It saved me time and allow me to read many questions in the same tag. So I could recognized variants of specific type of questions easily in the future.

It also avoid the unnecessary frustration in early phase. Many people may feel frustrated as they cannot even solve easy problems at the very beginning. Actually this is very common. Reading solution early on can actually help avoid that. I know some people may disagree with this point. Besides leetcode, I have compiled this list of resources that helped me. In my opinion, this is more effective for most of the people who are not guru in algorithms.

Note: if you are very new to the interview process of the big tech companies, cracking the coding interview is your friend. It demonstrates the hiring process in great details and cover some strategy for preparation.

I personally started from this book a few years ago. This helped me set the expectation of the interview so that I did not get any big surprise during the process. I then started try to solve problem without reading the solutions.

My submissions were a lot less between Jan and April. This slowdown is very critical for me to transition the memorization to practical problem solving skills in interview. By writing the code, it did reinforcement my understanding of the algorithms I learned.

During January to April, I attempted weekly contest as much as possible. I was never able to solve all four questions during the contest. Most of the time, I get 2 questions solved, sometimes 3. The advantage is that the contest provides the interview environment as it has time constraints. Luckily, I have a buddy who was preparing for interviews and we leetcoded together. We often discussed lc and shared resources like interview prep materials.

An example is that when I had difficulty understanding DP questions even like coin changemy friend can share me summary of DP questions that he found online. The summary talks about difference between bottom up vs top down solutions.Following are two Leetcode challenges. For both I used Python.

The first is Two Sum, which proved harder than Reverse Integer, and actually took me a couple of days. Despite this, both challenges are marked Easy.

In Two Sumwe are given an array of integers, and a specific number. We are told that exactly two integers in the array would add up to that number. Our job is to write a function which returns the indices of both numbers. To illustrate. Sounds easy right?

I thought so too, especially with an acceptance rate of I thought the strategy was since an answer was guaranteed, one just needed to subtract each array index from the target input integerthen iterate through the array to find the remainder.

Beware though it returns a ValueError when the number cannot be found. Sounds easy, but some challenges remain. Firstly, we should return [0, 1] and not [0,1,1,0]. There are multiple ways to deal with this. We should get [1, 2] and not [0,1,2]. Then it goes on to find the other two indices also sum to 6.

Remember list. So maybe we should check that remainder! This happens because we failed the case where remainder! Then the rest of the function fails to execute. This made me think for sometime before I hit upon a solution.

**GOOGLE CODING INTERVIEW QUESTION - KTH LARGEST ELEMENT IN AN ARRAY (LeetCode)**

What if we were to use combinatorics function instead to find all possible combinations of pairs to see if they summed to target? The python itertools library includes this method. Lol wtf, this is a thing?

As in we could actually find something that worked but is impractical and Leetcode tests for that too? Leetcode tells us the test case this fails is specifically. You get the idea. This test case was include specifically to throw off bruteforcing.

So what could I do next?I have been actively using leetcode as a platform to prepare for interviews for over 4 months now, and I feel I have learnt a few things along the way, that might or might not be useful for the other person looking for some direction, and getting a clear idea of how to progress on this journey. In the end, I want to mention that I am still not 'perfect' in solving problems, but leetcode have taught me a lot and I have definately come a long way in this process, and with a little guidance, determination and patience anyone can.

Any updates to the list are welcomed, so are any questions and do share your experiences of your leetcode journey, for everyone can benefit from each other's experiences.

Good Luck and Happy Leetcoding! Thanks for the list Pooja!

## Minimum number of jumps to reach end

Could you please share your created lists for Must-do Easy questions and Must-do Medium questions? This way it is more convenient for other users to clone your list and work on those problems. Thanks for the list. You solved around problems on LC. How many new problems not revisiting a problem that's already done did you solve everyday? How much time did it take? Hey Pooja!! Did you tried to make list of hard problems as well?

Thanks btw I think I have done most of the questions you have posted I sometimes wanted to revise then I think which questions should I revise now I can follow your list :. Hello Pooja! Thanks a lot for sharing these techniques. Definitely looks very comprehensive. Is it possible for you to share tricks, techniques, patterns that you learnt as you were solving these questions? Do you have a consolidated document with all of those? Thank you for taking out the time for compiling this list.

## Two-Sum Challenge in JavaScript

Surely motivating to see someone going through the same process. How to effectively use LeetCode to prepare for interviews!! Pooja Last Edit: December 17, AM Pick questions from each topic and try to master the basics of the topic.

Leverage the same and get your hand dirty. You will also find a healthy mix of the use of two-three data structures or algorithms in some problems. Look for such problems, for they are a great way to test your understanding of how more than one DS work together to build a beautiful solution. Must-do Easy questions [ Download the list here ] : Roman to Integer Valid Parentheses Merge Two Sorted Lists Linked List Cycle Min Stack I saw the hashtag on twitter and it inspired me to do some tutorials while spending most of my time indoors.

Hello, it has been a minute but I finally have a tutorial for you all: Sudoku Validator. I first saw this question on Pramp.

I finally came up with a great solution that I feel is teachable enough. My friend got asked this question from Squarespace two years ago and I finally decided to tackle it. I failed, but shout out to the internet for eventually giving me the answer. Hey everyone. Here is the video…. Hello everyone. I have another algorithm for you all today. I have two versions for you all, both in Python.

This post makes a copy of the original matrix and adds the correct values to it, the second…. Hey everyone, glad to finally get this tutorial out to you all. I hope to simplify it for you all….

Just to leave my feedback. Disclaimer: I am in no way being paid for this review and I…. The question is 3. I discovered this implementation on-line and commented it for better understanding. The video below is also an explanation of the process.

The stack of plates question basically asks that,…. Hello, Everyone. The first video below shows a visualization of what is expected. The second video is of me explaining the concept and implementing the code…. My 3rd question from Pramp.A quite popular challenge specially for Developer Interviews is what I stumbled upon in a Leetcode Problem.

This is a variation of the classic subset sum problem in computer science. Problems Statement - Given an array of integers, return indices of the two numbers such that they add up to a specific target. You may assume that each input would have exactly one solution, and you may not use the same element twice. And the index-no of that element i of that array to be the value in the key-value object.

Then in the second for loop, will check with hasOwnPropery if the key exists. And here the key that I am looking for will be the will be the compliment target - x. In this way, the look up time is reduced from O n to O 1 by trading space for speed. A hash table is built to achieve this. It supports fast look up in near constant time.

But look up in hash table should be amortized O 1 time as long as the hash function was chosen carefully. Since hash table has average access time O 1and we only access the array once. The time complexity of this solution is O n. Since we use the hash table as a temporary buffer, at worst case we need additional O n storage.

### Number Of Islands Tutorial (Python)

If it exists, we have found a solution and return immediately return [numsMap. Time complexity of above : O n. We traverse the list containing nn elements only once. Each look up in the table costs only O 1 time. Space complexity : O n. The extra space required depends on the number of items stored in the hash table, which stores at most nn elements. In this last solution above, I also used Map rather than use an object literal as a hash-map, given V8 has recently added significant performance improvements to Map and Set making them indispensable for lookups codes.

Sometime improving the performance of Map and Set iteration by up to a factor of 11 from Chrome 60 to Chrome Created a random array with elements and look at the substantial improvement in each subsequent solution. So, basically we are doing the checking in one-pass. SolutionBrute Force: